#!/bin/bash

NR_JOBS=2

[ -d darkcurrent ] || mkdir darkcurrent

control_c()
# run if user hits control-c
{
  echo -en "\n*** Ouch! Exiting ***\n"
  exit $?
}

count=0
for dir in "$@"; do
  name=$(basename $dir)
  dark=darkcurrent/DARK_$name.h5
  if [ ! -f $dark ]; then
      xrdtoolkit-average $dir/DARK_*.edf -o $dark &
  fi
  let count+=1
  [[ $((count%NR_JOBS)) -eq 0 ]] && wait # Limit to NR_JOBS concurrent jobs
done

