function c = constants(f);

c.c  = 299792458;        % (m/s) speed of light in vacuum (exact)
c.mu =   4.0e-7*pi;      % (N/A^2) magnetic constant mu_0 (exact)
c.Na =   6.0221415e23;   % Avogadro constants
c.kB =   1.3806505e-23;  % (J/K) Boltzmann constant
c.h  =   6.6260693e-34;  % (Js) Planck constnat
c.G  =   6.6742e-11;     % (m^3/kg/s^2) gravitation constant
c.e  =   1.60217653e-19; % (J) electron volt 
c.me = 510.998918;       % electron mass in keV

c.ep = 1/(c.mu*c.c^2);         % (F/m) electric constant eps_0
c.hc = 1e7*c.h*c.c/c.e;        % (keV A) hc
c.re = c.c^2*c.e/c.me;         % classical radius of electron in A
c.ia = 2*c.h/(c.e^2*c.mu*c.c); % 1/fine-structure

if nargin, c = getfield(c,f); end;
