function [F,r] = csft(k,f,r);
% function [F,r] = csft(k,f,r);

if (nargin == 3) & (nargout == 1),
  k = k(:); f = f(:); r = r(:)';
  [a,y,c] = cubgcv(k,f,1); F = csftc(k,f,c,r,0);
elseif (nargin == 2) & (nargout == 2),
  k = k(:); f = f(:); dk = diff(k);
  if any(diff(dk) < eps) & any(dk < 0),
    dk = abs(mean(dk)); nk = (0:length(k)-1)'*dk+min(k);
    f = splismo(k,f,nk); k = nk;
  else, dk = abs(mean(dk)); end;
  r = (0:length(k)-1)*(2*pi/(dk*length(k)));
  F = imag(fftshift(fft(f')).*exp(sqrt(-1)*k(1)*r));
else error('Wrong number of inputs and/or outputs'); end;
