function fo = forme(q,s);
% function f = forme(4*pi*sin(Theta)/lambda, compound)
%   Calculates the 'electronic' form factor for given compound (see mpr).

global XrayTable

if nargin < 2, error('Not enough input parameters'); end;
if nargin < 3, m = 0; end;
if nargin < 4, E = -1; end;
if length(XrayTable) == 0, load xraytable; end;

fo = zeros(size(q)); spl = q(:)/(4*pi); mthd = 'cubic';
si = find(spl <= 1); bi = find(1 < spl);
f = zeros(size(q));
[Z,w] = strtoz(s); N = length(Z); St = 0;
for i = 1:N,
  tf = XrayTable(Z(i)).factor;
  if ~isempty(si), f(si) = interp1(tf.s,tf.f,spl(si),'cubic'); end;
  if ~isempty(bi),
    f(bi) = interp1(log(tf.s(2:end)),tf.f(2:end),log(spl(bi)),'cubic');
  end;
  St = St + w(i)*f;
end;
fo(:) = St;
