function [cs,M] = getcs(E,z);
% function [cs,M] = getcs(E,z);

% Veijo Honkimaki, 29/10/98

global XrayTable

if length(XrayTable) == 0, load xraytable, end;
if length(XrayTable) ~= 100, error('Can''t load the x-ray database'); end;
if z < 1 | 92 < z, error('Z is out of range'); end;
le = log(E); B = XrayTable(z).Edge; A = [le.^0 le.^1 le.^2 le.^3];
cs = exp(A*XrayTable(z).Absorption);
Q = [(B(1)<=E) (B(2)<=E) (B(3)<=E) (B(4)<=E) (B(5)<=E) ones(size(E))];
Q(:,2:6) = Q(:,2:6).*(1-Q(:,1:5));
cs(:,1:6) = (cs(:,1:6).*Q)*XrayTable(z).JumpMatrix;
M = XrayTable(z).AtomicMass;
