function [s,ec] = kn(eo,tth,Pl)
% function [s (barn),Ec (keV)] = kn(Eo (keV), 2theta (deg), Pl)
%          Pl is the linear Stokes pol. par.

Con = constants;

if nargin < 3, Pl = 0; else Pl = Pl(:)'; end;
s = zeros(size(tth));
ec = zeros(size(tth));
eo = eo(:);
ct = cos(rad(tth(:)));
r2 = (Con.re*1e-8)^2*1e24;
k = 1./(1+eo.*(1-ct)/Con.me);
s(:) = r2*k.^2 .*(1./k + k - (1-Pl).*(1-ct.^2))/2;
ec(:) = eo.*k;
