function [m,M] = mpr(m,s);
%  [Mass absorption coefficient (cm^2/g), Density (g/cm^3),
%      Atomic mass (g/mol)] = mpr(E (keV), compound)
%      calculates the mass absorption coefficients for the given compound.
%      The compound can be the name or Z. For example 'C2H5OH' for ethanol
%      and 'AlO3' for alumina.

% Veijo Honkimaki, 29/10/98

[Z,w] = strtoz(s); k = length(Z); M = zeros(k,1); E = m(:); q = 0;
for i = 1:k,
  [cs,tM] = getcs(E,Z(i)); q = q + w(i)*cs; M(i) = w(i)*tM;
end;
m(:) = sum(q,2); end; m = m*(constants('Na')*1e-24/sum(M));
